{{- if .Values.gitHook.enabled -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "gitdata.fullname" . }}-git-hook
  namespace: {{ include "gitdata.namespace" . }}
  labels:
    app.kubernetes.io/name: {{ include "gitdata.fullname" . }}-git-hook
    app.kubernetes.io/instance: {{ .Release.Name }}
    app.kubernetes.io/version: {{ .Chart.AppVersion }}
spec:
  replicas: {{ .Values.gitHook.replicaCount | default 2 }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ include "gitdata.fullname" . }}-git-hook
      app.kubernetes.io/instance: {{ .Release.Name }}
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ include "gitdata.fullname" . }}-git-hook
        app.kubernetes.io/instance: {{ .Release.Name }}
    spec:
      {{- if $.Values.image.pullSecrets }}
      imagePullSecrets:
        {{- range $.Values.image.pullSecrets }}
        - name: {{ . }}
        {{- end }}
      {{- end }}
      containers:
        - name: git-hook
          image: "{{ .Values.image.registry }}/{{ .Values.gitHook.image.repository }}:{{ .Values.gitHook.image.tag }}"
          imagePullPolicy: {{ .Values.gitHook.image.pullPolicy | default .Values.image.pullPolicy }}
          envFrom:
            - configMapRef:
                name: {{ include "gitdata.fullname" . }}-config
          env:
            - name: APP_REPOS_ROOT
              value: /data/repos
            {{- range .Values.gitHook.env }}
            - name: {{ .name }}
              value: {{ .value | quote }}
            {{- end }}
          {{- if .Values.gitHook.livenessProbe }}
          livenessProbe:
            exec:
              command:
                {{- range .Values.gitHook.livenessProbe.exec.command }}
                - {{ . | quote }}
                {{- end }}
            initialDelaySeconds: {{ .Values.gitHook.livenessProbe.initialDelaySeconds }}
            periodSeconds: {{ .Values.gitHook.livenessProbe.periodSeconds }}
            timeoutSeconds: {{ .Values.gitHook.livenessProbe.timeoutSeconds }}
            failureThreshold: {{ .Values.gitHook.livenessProbe.failureThreshold }}
          {{- end }}
          {{- if .Values.gitHook.readinessProbe }}
          readinessProbe:
            exec:
              command:
                {{- range .Values.gitHook.readinessProbe.exec.command }}
                - {{ . | quote }}
                {{- end }}
            initialDelaySeconds: {{ .Values.gitHook.readinessProbe.initialDelaySeconds }}
            periodSeconds: {{ .Values.gitHook.readinessProbe.periodSeconds }}
            timeoutSeconds: {{ .Values.gitHook.readinessProbe.timeoutSeconds }}
            failureThreshold: {{ .Values.gitHook.readinessProbe.failureThreshold }}
          {{- end }}
          {{- if .Values.storage.enabled }}
          volumeMounts:
            - name: shared-data
              mountPath: /data
          {{- end }}
      {{- with .Values.gitHook.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.gitHook.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.gitHook.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- if .Values.storage.enabled }}
      volumes:
        - name: shared-data
          persistentVolumeClaim:
            claimName: {{ include "gitdata.fullname" . }}-shared-data
      {{- end }}
{{- end }}
